package lib.turtle;

typedef Block = Bool;

abstract Structure(Array<Layer>) from Array<Layer> {
	public inline function getLayer(i:Int):Layer {
		return this[i];
	}

	public inline function height():Int {
		return this.length;
	}
}

abstract Layer(Array<Array<Block>>) from Array<Array<Block>> {
	public inline function get(x:Int, y:Int):Block {
		return this[y][x];
	}

	public inline function width():Int {
		return this[0].length;
	}

	public inline function height():Int {
		return this.length;
	}

	public function getTextRepresentation():String {
		var str = "";
		for (y in 0...height()) {
			for (x in 0...width()) {
				if (get(x, y)) {
					str += "X";
				} else {
					str += " ";
				}
			}
			str += "\n";
		}
		return str;
	}
}
